#ifndef WEBWATCH_WATCHAPP_H
#define WEBWATCH_WATCHAPP_H

// ***************************************************************************
// System Includes
// ***************************************************************************

#include <Application.h>

// ***************************************************************************
// Project Includes
// ***************************************************************************

// Standard type and constant definitions.
#include "StyleGuideDefs.h"

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

class BView;

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

/** The MIME signature of our application. */
#define APP_SIGNATURE "application/x-vnd.WeirdExperiments.WebWatch2"

/** The name of our deskbar item. */
#define DESKBAR_ITEM_NAME "WebWatch2"

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

/** 
 * The WatchApp class installs the WatchView add-on into the Deskbar.
 * 
 * Because the application only runs less than a second, there is no need
 * for its title to appear inside the Deskbar. Therefore, the application
 * flags inside the resource file WebWatch.rsrc should be set to
 * B_BACKGROUND_APP.
 */
class WatchApp : public BApplication 
{
public:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

	/** Constructor. */
	WatchApp(void);

	/** Automatically generated copy constructor. */
	// WatchApp(const WatchApp& old);

	/** Automatically generated destructor. */
	// virtual ~WatchApp();

	/** Automatically generated assignment operator. */
	// WatchApp& operator=(WatchApp& right);

protected:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

private:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================
};

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

/** Instantiates the WatchView add-on that will be placed in the Deskbar. */
extern "C" _EXPORT BView* instantiate_deskbar_item(void);

#endif // WEBWATCH_WATCHAPP_H
